| OGRE 1.10.8 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Member Functions | List of all members
Ogre::GLSLMonolithicProgramManager Class Reference

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL has one program object that represents the active vertex and fragment shader objects during a rendering state. More...

`#include <OgreGLSLMonolithicProgramManager.h>`

Inheritance diagram for Ogre::GLSLMonolithicProgramManager:
[legend]

## Public Member Functions
| GLSLMonolithicProgramManager (GL3PlusRenderSystem *renderSystem)
| ~GLSLMonolithicProgramManager (void)
void | extractUniformsFromProgram (GLuint programObject, const GpuConstantDefinitionMap *(&constantDefs)[6], GLUniformReferenceList &uniformList, GLAtomicCounterReferenceList &counterList, GLUniformBufferList &uniformBufferList, SharedParamsBufferMap &sharedParamsBufferMap, GLCounterBufferList &counterBufferList)
| Populate a list of uniforms based on an OpenGL program object. More...
GLSLMonolithicProgram * | getActiveMonolithicProgram (void)
| Get the program object that links the two active shader objects together if a program object was not already created and linked a new one is created and linked. More...
GL3PlusStateCacheManager * | getStateCacheManager ()
void | setActiveComputeShader (GLSLShader *computeGpuProgram)
| Set the active compute shader for the next rendering state. More...
void | setActiveDomainShader (GLSLShader *domainGpuProgram)
| Set the active domain(evaluation) shader for the next rendering state. More...
void | setActiveFragmentShader (GLSLShader *fragmentGpuProgram)
| Set the active fragment shader for the next rendering state. More...
void | setActiveGeometryShader (GLSLShader *geometryGpuProgram)
| Set the active geometry shader for the next rendering state. More...
void | setActiveHullShader (GLSLShader *hullGpuProgram)
| Set the active hull(control) shader for the next rendering state. More...
void | setActiveVertexShader (GLSLShader *vertexGpuProgram)
| Set the active vertex shader for the next rendering state. More...

## Static Public Member Functions
static GLSLMonolithicProgramManager & | getSingleton (void)
static GLSLMonolithicProgramManager * | getSingletonPtr (void)

## Detailed Description

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL has one program object that represents the active vertex and fragment shader objects during a rendering state.

GLSL Vertex and fragment shader objects are compiled separately and then attached to a program object and then the program object is linked. Since Ogre can only handle one vertex program and one fragment program being active in a pass, the GLSL Link Program Manager does the same. The GLSL Link program manager acts as a state machine and activates a program object based on the active vertex and fragment program. Previously created program objects are stored along with a unique key in a hash_map for quick retrieval the next time the program object is required.

## Constructor & Destructor Documentation

## ◆ GLSLMonolithicProgramManager()

Ogre::GLSLMonolithicProgramManager::GLSLMonolithicProgramManager | ( | GL3PlusRenderSystem * | renderSystem | ) |

## ◆ ~GLSLMonolithicProgramManager()

Ogre::GLSLMonolithicProgramManager::~GLSLMonolithicProgramManager | ( | void |  | ) |

## Member Function Documentation

## ◆ getActiveMonolithicProgram()

GLSLMonolithicProgram* Ogre::GLSLMonolithicProgramManager::getActiveMonolithicProgram | ( | void |  | ) |

Get the program object that links the two active shader objects together if a program object was not already created and linked a new one is created and linked.

## ◆ setActiveVertexShader()

void Ogre::GLSLMonolithicProgramManager::setActiveVertexShader | ( | GLSLShader * | vertexGpuProgram | ) |

Set the active vertex shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLShader::bindProgram and unbindProgram methods

## ◆ setActiveHullShader()

void Ogre::GLSLMonolithicProgramManager::setActiveHullShader | ( | GLSLShader * | hullGpuProgram | ) |

Set the active hull(control) shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLShader::bindProgram and unbindProgram methods

## ◆ setActiveDomainShader()

void Ogre::GLSLMonolithicProgramManager::setActiveDomainShader | ( | GLSLShader * | domainGpuProgram | ) |

Set the active domain(evaluation) shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLShader::bindProgram and unbindProgram methods

## ◆ setActiveGeometryShader()

void Ogre::GLSLMonolithicProgramManager::setActiveGeometryShader | ( | GLSLShader * | geometryGpuProgram | ) |

Set the active geometry shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLShader::bindProgram and unbindProgram methods

## ◆ setActiveFragmentShader()

void Ogre::GLSLMonolithicProgramManager::setActiveFragmentShader | ( | GLSLShader * | fragmentGpuProgram | ) |

Set the active fragment shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLShader::bindProgram and unbindProgram methods

## ◆ setActiveComputeShader()

void Ogre::GLSLMonolithicProgramManager::setActiveComputeShader | ( | GLSLShader * | computeGpuProgram | ) |

Set the active compute shader for the next rendering state.

The active program object will be cleared. Normally called from the GLSLShader::bindProgram and unbindProgram methods

## ◆ getSingleton()

static GLSLMonolithicProgramManager& Ogre::GLSLMonolithicProgramManager::getSingleton | ( | void |  | ) |
| static

## ◆ getSingletonPtr()

static GLSLMonolithicProgramManager* Ogre::GLSLMonolithicProgramManager::getSingletonPtr | ( | void |  | ) |
| static

## ◆ extractUniformsFromProgram()

void Ogre::GLSLProgramManager::extractUniformsFromProgram | ( | GLuint | programObject,
|  | const GpuConstantDefinitionMap *(&) | constantDefs[6],
|  | GLUniformReferenceList & | uniformList,
|  | GLAtomicCounterReferenceList & | counterList,
|  | GLUniformBufferList & | uniformBufferList,
|  | SharedParamsBufferMap & | sharedParamsBufferMap,
|  | GLCounterBufferList & | counterBufferList
| ) |  |
| inherited

Populate a list of uniforms based on an OpenGL program object.

## ◆ getStateCacheManager()

GL3PlusStateCacheManager* Ogre::GLSLProgramManager::getStateCacheManager | ( |  | ) |
| inherited

The documentation for this class was generated from the following file:

- OgreGLSLMonolithicProgramManager.h